diff --git a/mm/hugetlb.c b/mm/hugetlb.c
index 4434cdd..90953e1 100644
--- a/mm/hugetlb.c
+++ b/mm/hugetlb.c
@@ -39,7 +39,60 @@ int hugepages_treat_as_movable;
 
 int hugetlb_max_hstate __read_mostly;
 unsigned int default_hstate_idx;
-struct hstate hstates[HUGE_MAX_HSTATE];
+
+#ifdef CONFIG_CGROUP_HUGETLB
+static struct cftype hugetlb_files[HUGE_MAX_HSTATE][5] = {
+# define MEMFILE_PRIVATE(x, val)	(((x) << 16) | (val))
+# define CFTYPE_INIT(idx) \
+	{ /* Add the limit file */					\
+	  [0] = { .private = MEMFILE_PRIVATE(idx, RES_LIMIT),		\
+		  .read_u64 = hugetlb_cgroup_read_u64,			\
+		  .write = hugetlb_cgroup_write, },			\
+	  /* Add the usage file */					\
+	  [1] = { .private = MEMFILE_PRIVATE(idx, RES_USAGE),		\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  /* Add the MAX usage file */					\
+	  [2] = { .private = MEMFILE_PRIVATE(idx, RES_MAX_USAGE),	\
+		  .write = hugetlb_cgroup_reset,			\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  /* Add the failcntfile */					\
+	  [3] = { .private = MEMFILE_PRIVATE(idx, RES_FAILCNT),		\
+		  .write = hugetlb_cgroup_reset,			\
+		  .read_u64 = hugetlb_cgroup_read_u64, },		\
+	  [4] = { /* NULL terminator */ },				\
+	}
+
+# if HUGE_MAX_HSTATE > 0
+	[0] = CFTYPE_INIT(0),
+# endif
+# if HUGE_MAX_HSTATE > 1
+	[1] = CFTYPE_INIT(1),
+# endif
+# if HUGE_MAX_HSTATE > 2
+#  error PaX: add more initializers...
+# endif
+
+# undef CFTYPE_INIT
+};
+#endif
+
+struct hstate hstates[HUGE_MAX_HSTATE] = {
+#ifdef CONFIG_CGROUP_HUGETLB
+# define HSTATE_INIT(idx) [idx] = { .cgroup_files = &hugetlb_files[idx] }
+
+# if HUGE_MAX_HSTATE > 0
+	HSTATE_INIT(0),
+# endif
+# if HUGE_MAX_HSTATE > 1
+	HSTATE_INIT(1),
+# endif
+# if HUGE_MAX_HSTATE > 2
+#  error PaX: add more initializers...
+# endif
+
+# undef HSTATE_INIT
+#endif
+};
 /*
  * Minimum page order among possible hugepage sizes, set to a proper value
  * at boot time.
@@ -2785,6 +2838,7 @@ static int hugetlb_sysctl_handler_common(bool obey_mempolicy,
 			 struct ctl_table *table, int write,
 			 void __user *buffer, size_t *length, loff_t *ppos)
 {
+	ctl_table_no_const t;
 	struct hstate *h = &default_hstate;
 	unsigned long tmp = h->max_huge_pages;
 	int ret;
@@ -2792,9 +2846,10 @@ static int hugetlb_sysctl_handler_common(bool obey_mempolicy,
 	if (!hugepages_supported())
 		return -ENOTSUPP;
 
-	table->data = &tmp;
-	table->maxlen = sizeof(unsigned long);
-	ret = proc_doulongvec_minmax(table, write, buffer, length, ppos);
+	t = *table;
+	t.data = &tmp;
+	t.maxlen = sizeof(unsigned long);
+	ret = proc_doulongvec_minmax(&t, write, buffer, length, ppos);
 	if (ret)
 		goto out;
 
@@ -2829,6 +2884,7 @@ int hugetlb_overcommit_handler(struct ctl_table *table, int write,
 	struct hstate *h = &default_hstate;
 	unsigned long tmp;
 	int ret;
+	ctl_table_no_const hugetlb_table;
 
 	if (!hugepages_supported())
 		return -ENOTSUPP;
@@ -2838,9 +2894,10 @@ int hugetlb_overcommit_handler(struct ctl_table *table, int write,
 	if (write && hstate_is_gigantic(h))
 		return -EINVAL;
 
-	table->data = &tmp;
-	table->maxlen = sizeof(unsigned long);
-	ret = proc_doulongvec_minmax(table, write, buffer, length, ppos);
+	hugetlb_table = *table;
+	hugetlb_table.data = &tmp;
+	hugetlb_table.maxlen = sizeof(unsigned long);
+	ret = proc_doulongvec_minmax(&hugetlb_table, write, buffer, length, ppos);
 	if (ret)
 		goto out;
 
@@ -3346,6 +3403,27 @@ static void unmap_ref_private(struct mm_struct *mm, struct vm_area_struct *vma,
 	i_mmap_unlock_write(mapping);
 }
 
+#ifdef CONFIG_PAX_SEGMEXEC
+static void pax_mirror_huge_pte(struct vm_area_struct *vma, unsigned long address, struct page *page_m)
+{
+	struct mm_struct *mm = vma->vm_mm;
+	struct vm_area_struct *vma_m;
+	unsigned long address_m;
+	pte_t *ptep_m;
+
+	vma_m = pax_find_mirror_vma(vma);
+	if (!vma_m)
+		return;
+
+	BUG_ON(address >= SEGMEXEC_TASK_SIZE);
+	address_m = address + SEGMEXEC_TASK_SIZE;
+	ptep_m = huge_pte_offset(mm, address_m & HPAGE_MASK);
+	get_page(page_m);
+	hugepage_add_anon_rmap(page_m, vma_m, address_m);
+	set_huge_pte_at(mm, address_m, ptep_m, make_huge_pte(vma_m, page_m, 0));
+}
+#endif
+
 /*
  * Hugetlb_cow() should be called with page lock of the original hugepage held.
  * Called with hugetlb_instantiation_mutex held and pte_page locked so we
@@ -3459,6 +3537,11 @@ retry_avoidcopy:
 				make_huge_pte(vma, new_page, 1));
 		page_remove_rmap(old_page);
 		hugepage_add_new_anon_rmap(new_page, vma, address);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+		pax_mirror_huge_pte(vma, address, new_page);
+#endif
+
 		/* Make the old page be freed below */
 		new_page = old_page;
 	}
@@ -3632,6 +3715,10 @@ retry:
 				&& (vma->vm_flags & VM_SHARED)));
 	set_huge_pte_at(mm, address, ptep, new_pte);
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	pax_mirror_huge_pte(vma, address, page);
+#endif
+
 	hugetlb_count_add(pages_per_huge_page(h), mm);
 	if ((flags & FAULT_FLAG_WRITE) && !(vma->vm_flags & VM_SHARED)) {
 		/* Optimization, do the COW without a second fault */
@@ -3700,6 +3787,10 @@ int hugetlb_fault(struct mm_struct *mm, struct vm_area_struct *vma,
 	struct address_space *mapping;
 	int need_wait_lock = 0;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	address &= huge_page_mask(h);
 
 	ptep = huge_pte_offset(mm, address);
@@ -3717,6 +3808,26 @@ int hugetlb_fault(struct mm_struct *mm, struct vm_area_struct *vma,
 			return VM_FAULT_OOM;
 	}
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m) {
+		unsigned long address_m;
+
+		if (vma->vm_start > vma_m->vm_start) {
+			address_m = address;
+			address -= SEGMEXEC_TASK_SIZE;
+			vma = vma_m;
+			h = hstate_vma(vma);
+		} else
+			address_m = address + SEGMEXEC_TASK_SIZE;
+
+		if (!huge_pte_alloc(mm, address_m, huge_page_size(h)))
+			return VM_FAULT_OOM;
+		address_m &= HPAGE_MASK;
+		unmap_hugepage_range(vma, address_m, address_m + HPAGE_SIZE, NULL);
+	}
+#endif
+
 	mapping = vma->vm_file->f_mapping;
 	idx = vma_hugecache_offset(h, vma, address);
 
diff --git a/mm/hugetlb_cgroup.c b/mm/hugetlb_cgroup.c
index d8fb10d..1c74822 100644
--- a/mm/hugetlb_cgroup.c
+++ b/mm/hugetlb_cgroup.c
@@ -27,7 +27,6 @@ struct hugetlb_cgroup {
 	struct page_counter hugepage[HUGE_MAX_HSTATE];
 };
 
-#define MEMFILE_PRIVATE(x, val)	(((x) << 16) | (val))
 #define MEMFILE_IDX(val)	(((val) >> 16) & 0xffff)
 #define MEMFILE_ATTR(val)	((val) & 0xffff)
 
@@ -238,14 +237,7 @@ void hugetlb_cgroup_uncharge_cgroup(int idx, unsigned long nr_pages,
 	return;
 }
 
-enum {
-	RES_USAGE,
-	RES_LIMIT,
-	RES_MAX_USAGE,
-	RES_FAILCNT,
-};
-
-static u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
+u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
 				   struct cftype *cft)
 {
 	struct page_counter *counter;
@@ -269,7 +261,7 @@ static u64 hugetlb_cgroup_read_u64(struct cgroup_subsys_state *css,
 
 static DEFINE_MUTEX(hugetlb_limit_mutex);
 
-static ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
+ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
 				    char *buf, size_t nbytes, loff_t off)
 {
 	int ret, idx;
@@ -299,7 +291,7 @@ static ssize_t hugetlb_cgroup_write(struct kernfs_open_file *of,
 	return ret ?: nbytes;
 }
 
-static ssize_t hugetlb_cgroup_reset(struct kernfs_open_file *of,
+ssize_t hugetlb_cgroup_reset(struct kernfs_open_file *of,
 				    char *buf, size_t nbytes, loff_t off)
 {
 	int ret = 0;
@@ -335,46 +327,26 @@ static char *mem_fmt(char *buf, int size, unsigned long hsize)
 
 static void __init __hugetlb_cgroup_file_init(int idx)
 {
+	char names[4][MAX_CFTYPE_NAME];
 	char buf[32];
-	struct cftype *cft;
 	struct hstate *h = &hstates[idx];
 
 	/* format the size */
 	mem_fmt(buf, 32, huge_page_size(h));
-
-	/* Add the limit file */
-	cft = &h->cgroup_files[0];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.limit_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_LIMIT);
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-	cft->write = hugetlb_cgroup_write;
-
-	/* Add the usage file */
-	cft = &h->cgroup_files[1];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.usage_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_USAGE);
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* Add the MAX usage file */
-	cft = &h->cgroup_files[2];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.max_usage_in_bytes", buf);
-	cft->private = MEMFILE_PRIVATE(idx, RES_MAX_USAGE);
-	cft->write = hugetlb_cgroup_reset;
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* Add the failcntfile */
-	cft = &h->cgroup_files[3];
-	snprintf(cft->name, MAX_CFTYPE_NAME, "%s.failcnt", buf);
-	cft->private  = MEMFILE_PRIVATE(idx, RES_FAILCNT);
-	cft->write = hugetlb_cgroup_reset;
-	cft->read_u64 = hugetlb_cgroup_read_u64;
-
-	/* NULL terminate the last cft */
-	cft = &h->cgroup_files[4];
-	memset(cft, 0, sizeof(*cft));
+	snprintf(names[0], MAX_CFTYPE_NAME, "%s.limit_in_bytes", buf);
+	snprintf(names[1], MAX_CFTYPE_NAME, "%s.usage_in_bytes", buf);
+	snprintf(names[2], MAX_CFTYPE_NAME, "%s.max_usage_in_bytes", buf);
+	snprintf(names[3], MAX_CFTYPE_NAME, "%s.failcnt", buf);
+
+	pax_open_kernel();
+	strncpy((void *)(*h->cgroup_files)[0].name, names[0], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[1].name, names[1], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[2].name, names[2], MAX_CFTYPE_NAME);
+	strncpy((void *)(*h->cgroup_files)[3].name, names[3], MAX_CFTYPE_NAME);
+	pax_close_kernel();
 
 	WARN_ON(cgroup_add_legacy_cftypes(&hugetlb_cgrp_subsys,
-					  h->cgroup_files));
+					  *h->cgroup_files));
 }
 
 void __init hugetlb_cgroup_file_init(void)
diff --git a/mm/internal.h b/mm/internal.h
index 6979b2b..6a6b465 100644
--- a/mm/internal.h
+++ b/mm/internal.h
@@ -178,6 +178,7 @@ __find_buddy_index(unsigned long page_idx, unsigned int order)
 extern int __isolate_free_page(struct page *page, unsigned int order);
 extern void __free_pages_bootmem(struct page *page, unsigned long pfn,
 					unsigned int order);
+extern void free_compound_page(struct page *page);
 extern void prep_compound_page(struct page *page, unsigned int order);
 #ifdef CONFIG_MEMORY_FAILURE
 extern bool is_free_buddy_page(struct page *page);
diff --git a/mm/kmemleak.c b/mm/kmemleak.c
index 19423a4..f591ad4 100644
--- a/mm/kmemleak.c
+++ b/mm/kmemleak.c
@@ -366,7 +366,7 @@ static void print_unreferenced(struct seq_file *seq,
 
 	for (i = 0; i < object->trace_len; i++) {
 		void *ptr = (void *)object->trace[i];
-		seq_printf(seq, "    [<%p>] %pS\n", ptr, ptr);
+		seq_printf(seq, "    [<%pP>] %pA\n", ptr, ptr);
 	}
 }
 
@@ -1958,7 +1958,7 @@ static int __init kmemleak_late_init(void)
 		return -ENOMEM;
 	}
 
-	dentry = debugfs_create_file("kmemleak", S_IRUGO, NULL, NULL,
+	dentry = debugfs_create_file("kmemleak", S_IRUSR, NULL, NULL,
 				     &kmemleak_fops);
 	if (!dentry)
 		pr_warning("Failed to create the debugfs kmemleak file\n");
diff --git a/mm/maccess.c b/mm/maccess.c
index d159b1c..7655796 100644
--- a/mm/maccess.c
+++ b/mm/maccess.c
@@ -28,12 +28,12 @@ long __probe_kernel_read(void *dst, const void *src, size_t size)
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
-	set_fs(KERNEL_DS);
 	pagefault_disable();
+	set_fs(KERNEL_DS);
 	ret = __copy_from_user_inatomic(dst,
-			(__force const void __user *)src, size);
-	pagefault_enable();
+			(const void __force_user *)src, size);
 	set_fs(old_fs);
+	pagefault_enable();
 
 	return ret ? -EFAULT : 0;
 }
@@ -56,11 +56,11 @@ long __probe_kernel_write(void *dst, const void *src, size_t size)
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
-	set_fs(KERNEL_DS);
 	pagefault_disable();
-	ret = __copy_to_user_inatomic((__force void __user *)dst, src, size);
-	pagefault_enable();
+	set_fs(KERNEL_DS);
+	ret = __copy_to_user_inatomic((void __force_user *)dst, src, size);
 	set_fs(old_fs);
+	pagefault_enable();
 
 	return ret ? -EFAULT : 0;
 }
diff --git a/mm/madvise.c b/mm/madvise.c
index c889fcb..f181221 100644
--- a/mm/madvise.c
+++ b/mm/madvise.c
@@ -52,6 +52,10 @@ static long madvise_behavior(struct vm_area_struct *vma,
 	pgoff_t pgoff;
 	unsigned long new_flags = vma->vm_flags;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	switch (behavior) {
 	case MADV_NORMAL:
 		new_flags = new_flags & ~VM_RAND_READ & ~VM_SEQ_READ;
@@ -128,6 +132,13 @@ success:
 	/*
 	 * vm_flags is protected by the mmap_sem held in write mode.
 	 */
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m)
+		vma_m->vm_flags = new_flags & ~(VM_WRITE | VM_MAYWRITE | VM_ACCOUNT);
+#endif
+
 	vma->vm_flags = new_flags;
 
 out:
@@ -279,11 +290,27 @@ static long madvise_dontneed(struct vm_area_struct *vma,
 			     struct vm_area_struct **prev,
 			     unsigned long start, unsigned long end)
 {
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	struct vm_area_struct *vma_m;
+#endif
+
 	*prev = vma;
 	if (vma->vm_flags & (VM_LOCKED|VM_HUGETLB|VM_PFNMAP))
 		return -EINVAL;
 
 	zap_page_range(vma, start, end - start, NULL);
+
+#ifdef CONFIG_PAX_SEGMEXEC
+	vma_m = pax_find_mirror_vma(vma);
+	if (vma_m) {
+		if (vma_m->vm_flags & (VM_LOCKED|VM_HUGETLB|VM_PFNMAP))
+			return -EINVAL;
+
+		zap_page_range(vma_m, start + SEGMEXEC_TASK_SIZE, end - start, NULL);
+	}
+#endif
+
 	return 0;
 }
 
@@ -486,6 +513,16 @@ SYSCALL_DEFINE3(madvise, unsigned long, start, size_t, len_in, int, behavior)
 	if (end < start)
 		return error;
 
+#ifdef CONFIG_PAX_SEGMEXEC
+	if (current->mm->pax_flags & MF_PAX_SEGMEXEC) {
+		if (end > SEGMEXEC_TASK_SIZE)
+			return error;
+	} else
+#endif
+
+	if (end > TASK_SIZE)
+		return error;
+
 	error = 0;
 	if (end == start)
 		return error;
diff --git a/mm/memcontrol.c b/mm/memcontrol.c
index 5d9c8a3..cfa1adb 100644
--- a/mm/memcontrol.c
+++ b/mm/memcontrol.c
@@ -796,7 +796,7 @@ static void memcg_check_events(struct mem_cgroup *memcg, struct page *page)
 			mem_cgroup_update_tree(memcg, page);
 #if MAX_NUMNODES > 1
 		if (unlikely(do_numainfo))
-			atomic_inc(&memcg->numainfo_events);
+			atomic64_inc(&memcg->numainfo_events);
 #endif
 	}
 }
@@ -1438,7 +1438,7 @@ static void mem_cgroup_may_update_nodemask(struct mem_cgroup *memcg)
 	 * numainfo_events > 0 means there was at least NUMAINFO_EVENTS_TARGET
 	 * pagein/pageout changes since the last update.
 	 */
-	if (!atomic_read(&memcg->numainfo_events))
+	if (!atomic64_read(&memcg->numainfo_events))
 		return;
 	if (atomic_inc_return(&memcg->numainfo_updating) > 1)
 		return;
@@ -1452,7 +1452,7 @@ static void mem_cgroup_may_update_nodemask(struct mem_cgroup *memcg)
 			node_clear(nid, memcg->scan_nodes);
 	}
 
-	atomic_set(&memcg->numainfo_events, 0);
+	atomic64_set(&memcg->numainfo_events, 0);
 	atomic_set(&memcg->numainfo_updating, 0);
 }
 
diff --git a/mm/memory-failure.c b/mm/memory-failure.c
index 750b789..b1b1b59 100644
--- a/mm/memory-failure.c
+++ b/mm/memory-failure.c
@@ -64,7 +64,7 @@ int sysctl_memory_failure_early_kill __read_mostly = 0;
 
 int sysctl_memory_failure_recovery __read_mostly = 1;
 
-atomic_long_t num_poisoned_pages __read_mostly = ATOMIC_LONG_INIT(0);
+atomic_long_unchecked_t num_poisoned_pages __read_mostly = ATOMIC_LONG_INIT(0);
 
 #if defined(CONFIG_HWPOISON_INJECT) || defined(CONFIG_HWPOISON_INJECT_MODULE)
 
@@ -189,7 +189,7 @@ static int kill_proc(struct task_struct *t, unsigned long addr, int trapno,
 		pfn, t->comm, t->pid);
 	si.si_signo = SIGBUS;
 	si.si_errno = 0;
-	si.si_addr = (void *)addr;
+	si.si_addr = (void __user *)addr;
 #ifdef __ARCH_SI_TRAPNO
 	si.si_trapno = trapno;
 #endif
@@ -784,7 +784,7 @@ static struct page_state {
 	unsigned long res;
 	enum mf_action_page_type type;
 	int (*action)(struct page *p, unsigned long pfn);
-} error_states[] = {
+} __do_const error_states[] = {
 	{ reserved,	reserved,	MF_MSG_KERNEL,	me_kernel },
 	/*
 	 * free pages are specially detected outside this table:
